/**
 * @file local-distrib.i
 * @brief Casting to most specific packages object for ruby
 * @author SBMLTeam
 *
 * <!--------------------------------------------------------------------------
 * This file is part of libSBML. Please visit http://sbml.org for more
 * information about SBML, and the latest version of libSBML.
 *
 * Copyright (C) 2019 jointly by the following organizations:
 * 1. California Institute of Technology, Pasadena, CA, USA
 * 2. University of Heidelberg, Heidelberg, Germany
 *
 * Copyright (C) 2013-2018 jointly by the following organizations:
 * 1. California Institute of Technology, Pasadena, CA, USA
 * 2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
 * 3. University of Heidelberg, Heidelberg, Germany
 *
 * Copyright (C) 2009-2013 jointly by the following organizations:
 * 1. California Institute of Technology, Pasadena, CA, USA
 * 2. EMBL European Bioinformatics Institute (EMBL-EBI), Hinxton, UK
 *
 * Copyright (C) 2006-2008 by the California Institute of Technology,
 * Pasadena, CA, USA
 *
 * Copyright (C) 2002-2005 jointly by the following organizations:
 * 1. California Institute of Technology, Pasadena, CA, USA
 * 2. Japan Science and Technology Agency, Japan
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation. A copy of the license agreement is provided in the
 * file named "LICENSE.txt" included with this software distribution and also
 * available online as http://sbml.org/software/libsbml/license.html
 * ------------------------------------------------------------------------ -->
 */


#ifdef USE_DISTRIB

SBMLCONSTRUCTOR_EXCEPTION(DistribPkgNamespaces)
SBMLCONSTRUCTOR_EXCEPTION(UncertParameter)
SBMLCONSTRUCTOR_EXCEPTION(Uncertainty)
SBMLCONSTRUCTOR_EXCEPTION(UncertSpan)
SBMLCONSTRUCTOR_EXCEPTION(DistribBase)
SBMLCONSTRUCTOR_EXCEPTION(ListOfUncertParameters)
SBMLCONSTRUCTOR_EXCEPTION(ListOfUncertainties)

/**
 * Convert UncertParameter objects into the most specific object possible.
 */
%typemap(out) UncertParameter*
{
  $result = SWIG_NewPointerObj($1, GetDowncastSwigTypeForPackage($1,
    "distrib"), $owner | %newpointer_flags);
}

/**
 * Convert DistribBase objects into the most specific object possible.
 */
%typemap(out) DistribBase*
{
  $result = SWIG_NewPointerObj($1, GetDowncastSwigTypeForPackage($1,
    "distrib"), $owner | %newpointer_flags);
}


#endif // USE_DISTRIB

